// mark temp
var gulp = require('gulp');
var plugins = require('gulp-load-plugins')();
var watcher = {
    cache : {},
    set : function(task, files){
        if ( !this.cache[task] ) {
            gulp.watch(files, [task]);
            this.cache[task] = true;
        }
    }
};

var root = '.';
var lib = './lib';
var src = './src';

gulp.task('default', function(){
    var files = [
        lib + '/angular-notify/dist/angular-notify.js',
        lib + '/clipboard/dist/clipboard.js',
        lib + '/ngclipboard/dist/ngclipboard.js',
        lib + '/angular-notify/angular-notify.js',
        src + '/main.js',
        src + '/utils/for-jquery.js',
        src + '/utils/directive-includes.js',
        src + '/utils/directive-key-to-text.js',
        src + '/utils/directive-toggle-classes.js',
        src + '/utils/factory-base-service.js',
        src + '/utils/factory-data-convert.js',
        src + '/utils/factory-flat.js',
        src + '/utils/factory-helpers.js',
        src + '/utils/factory-http-interceptor.js',
        src + '/utils/factory-inject-service.js',
        src + '/utils/factory-list.js',
        src + '/utils/factory-location.js',
        src + '/utils/factory-runtime.js',
        src + '/utils/factory-tab-index.js',
        src + '/utils/factory-tree-json.js',
        src + '/utils/filter-datetime.js',
        src + '/utils/filter-nl2br.js',
        src + '/utils/filter-nl2li.js',
        src + '/utils/filter-round.js',
        src + '/utils/filter-trusted.js',
        src + '/utils/filter-join.js',
        src + '/utils/filter-replace.js',
        src + '/utils/provider-ajax.js',
        src + '/utils/provider-dialog.js',
        src + '/utils/service-route-menu.js',
        src + '/control/directive-list-status.js',
        src + '/control/directive-ui-alert-error.js',
        src + '/control/directive-checklist-model.js',
        src + '/control/directive-bool.js',
        src + '/control/directive-bootstrap-tooltip.js',
        src + '/control/directive-datatime-picker.js',
        src + '/control/directive-disabled-when.js',
        src + '/control/directive-icheck.js',
        src + '/control/directive-landers-pagebar.js',
        src + '/control/directive-protip.js',
        src + '/control/directive-remedy-select.js',
        src + '/control/directive-landers-name-value-inputer.js',
        src + '/control/directive-drop-select.js',
        src + '/control/directive-include-replace.js',
        src + '/control/directive-mcustomer-scroll.js',
        src + '/control/directive-iscroll.js',
        src + '/control/directive-loading-icon.js',
        src + '/control/directive-input-radio-or-text.js',
        src + '/main/api.js',
        src + '/main/model.js',
        src + '/main/app.js',
        src + '/other/echarts.js',

        src + '/utils/factory-promise-loads.js',
        src + '/control/directive-money.js',
        src + '/control/directive-button-radio.js',
        src + '/control/directive-button-checkbox.js',
        src + '/control/directive-copy-text.js',
        src + '/control/directive-dataslider.js',
        src + '/utils/provider-gwebsocket.js',
        src + '/utils/provider-gnotify.js',
        src + '/control/directive-landers-raty.js',
        src + '/control/directive-landers-attachment.js',
        src + '/control/directive-landers-tab.js',
        src + '/control/directive-landers-upload.js',
        src + '/control/directive-landers-tree-select.js',
        src + '/control/directive-ueditor.js',
        src + '/control/directive-breadcrumbs.js'
    ];

    gulp.src(files)
        .pipe(plugins.concat('landers.angular.js'))
        .pipe(gulp.dest(root + '/dist'));
    watcher.set('default', files);


    var files = [
        lib + '/angular-notify/dist/angular-notify.css',
        lib + '/angular-notify/dist/angular-notify-theme.css',
    ];

    gulp.src(files)
        .pipe(plugins.concat('landers.angular.css'))
        .pipe(plugins.minifyCss())
        .pipe(gulp.dest(root + '/dist'));
});

// gulp.watch('gulpfile.js', ['default']);