;angular.module('Landers.angular')
    .directive('crudDoItem', function(){
        return {
            restrict : 'A',
            link : function($scope, $element, $attrs){
                $element.addClass('doitem')
                    .children('a, button').not('.btn').addClass('btn ')
                    .each(function(){
                        if ($(this).attr('class').indexOf('btn-') < 0 ) {
                            $(this).addClass('btn-primary');
                        }
                    })
            }
        }
    })
    .directive('subnav', ['$rootScope', function($rootScope){
        return {
            restrict: 'A',
            link: function($scope, $element, $attrs){
                // $scope.$on('clearSubnav', function(event){
                //     $element.empty()
                // });
                // $scope.$on('showSubnav', function(event, $subnav){
                //     $element.append($subnav);
                // });
                $scope.$emit('SetSubnavOjbect', $element);
            }
        }
    }])
    .directive('lockInput', ['$compile', '$timeout', 'Runtime', function($compile, $timeout, Runtime){
        return {
            restrict: 'A',
            link: function($scope, $element, $attrs){
                var get_lock_key = function() {
                    var lock_key = $attrs['lockInputKey'];
                    if (!lock_key) {
                        var ngModel = $attrs['ngModel'];
                        var arr = ngModel.split('.');
                        lock_key= arr[arr.length-1];
                    }
                    return lock_key;
                }

                var key = get_lock_key();
                var runtime = Runtime.make($scope);

                $scope.$watch(function(){
                    return $attrs['lockInputInit'];
                }, function(init){
                    if (init === undefined) return;
                    runtime.set('lockInput', init==='true', key);
                    var $wraper = $element.parent();
                    if ($wraper.find('.btn-lock-input').length) return;

                    var $input_group = $wraper.hasClass('input-group') ? $wraper : (function(){
                        var $ret = $('<div class="input-group"></div>').appendTo($wraper);
                        $ret.append($element);
                        return $ret;
                    }());

                    var $input_group_addon = $input_group.find('.input-group-addon');
                    if (!$input_group_addon.length) {
                        $input_group_addon = $('<div class="input-group-addon"></div>').appendTo($input_group);
                    }

                    var html = '';
                    html += '<a class="btn-lock-input lock-input-on" ng-if="$runtime.lockInput.' + key + '" href="javascript:;" ng-click="unlockInput(\'' + key + '\')">启用编辑</a>';
                    html += '<a class="btn-lock-input lock-input-on" ng-if="!$runtime.lockInput.' + key + '" href="javascript:;" ng-click="lockInput(\'' + key + '\')">禁用编辑</a>';
                    $input_group_addon.append($compile(html)($scope));
                });

                angular.extend($scope, {
                    unlockInput: function(lock_key){
                        runtime.set('lockInput', false, lock_key);
                    },
                    lockInput: function(lock_key){
                        runtime.set('lockInput', true, lock_key);
                    }
                });
            }
        }
    }])
    .provider('AngularApp', function () {
        var provider = this;

        this.cache = false;

        this.path = {
            module: null,
            component: null
        };

        this.extras = {};

        this.needCss = false;

        this.modulePath = function(module){
            return (provider.extras[module] || provider.path.module) + '/' + module;
        };

        provider.showDialogError = function(dialog, rspn) {
            if ( rspn.errors ) {
                var errors = Object.values(rspn.errors);

                if ( errors.length > 1) {
                    errors = errors.map(function(value, index){
                        return '<li>' + value + '</li>';
                    });
                    errors.splice(0, 0, '<ul>');
                    errors.push('</ul>')
                    rspn.message = errors.join('');
                    Landers.msgbox({
                        succes: false,
                        message : rspn.message
                    });
                    dialog.done();
                } else {
                    rspn.message = errors.join('');
                    dialog.done(rspn);
                }
            } else {
                Landers.msgbox({
                    succes: false,
                    message : rspn.message
                });
                dialog.done();
            }
        };

        provider.cache = {
            injectedApps: {}
        };

        this.$get = ['$state', 'Ajax', 'Runtime', 'AngularModel', 'Dialog', '$templateRequest', 'Flat', '$timeout', 'InjectService', '$compile', 'Helpers', '$rootScope', '$compile', function ($state, Ajax, Runtime, AngularModel, Dialog, $templateRequest, Flat, $timeout, InjectService, $compile, Helpers, $rootScope, $compile) {
            var defaults = {
                dialog : {
                    width : 800,
                    height : '100%',
                    scroll : true
                },
                partials: {

                }
            };

            function DynamicInjecte(scope) {
                var that = this;

                function parse_path_info(path) {
                    var a = path.split('/');
                    if ( a.length == 1) {
                        return {dir: path, file: ''} ;
                    } else {
                        var file = a[a.length-1];
                        a.length--;
                        return {
                            dir: a.join('/'),
                            file: file
                        };
                    }
                }

                this.getAppResourcesUrl = function(module){
                    var base_path = provider.modulePath(module);
                    return [
                        base_path + '/style.css',
                        base_path + '/client.js'
                    ];
                };
                // this.injectedModules = {};
                this.injectModule = function(module, injects){
                    // var modules = that.injectedModules[module];
                    // if (!modules) {
                        var urls = that.getAppResourcesUrl(module);
                        InjectService.module(urls, injects);
                    // } else {
                        // callback.apply(this, modules);
                    // }
                };
                this.injectedApps = {};
                this.bootApp = function(path, callback_controller) {
                    var path_info = parse_path_info(path);
                    var urls = that.getAppResourcesUrl(path_info.dir);
                    var callback = function(){
                        if (angular.isString(callback_controller)) {
                            that.bootController(callback_controller);
                        }
                        if (angular.isFunction(callback_controller)){
                            var mod_path = provider.modulePath(path_info.dir); // provider.path.module + '/' + path_info.dir;
                            var main_url = mod_path + '/' + (path_info.file || 'layout.html');
                            that.bootController(main_url);
                            $timeout(function(){
                                callback_controller(scope);
                            }, 200);
                        }
                        that.injectedApps[path] = true;
                    }

                    if (!that.injectedApps[path]) {
                        InjectService.urls(urls, callback);
                    } else {
                        callback();
                    }
                };
                this.injectedControllers = {};
                this.bootController = function (controller_url, reload){
                    if (!that.injectedControllers[controller_url] || reload) {
                        var html = controller_url.indexOf('/') >= 0 ?
                                   '<div ng-include="\'' + controller_url + '\'"></div>' :
                                   '<div ng-controller="' + controller_url + '"></div>';
                        var el = $compile(html)(scope);
                        angular.element('#base-body, .base-body').append(el);
                        angular_scope_apply(scope);
                        that.injectedControllers[controller_url] = true;
                    };
                };
                this.resetInjectCache = function() {
                    that.injectedControllers = {};
                    that.injectedModules = {};
                    that.injectedApps = {};
                };
            };

            var SubnavManager = {
                dom: null,
                hadInit: function(){
                    return !!this.dom
                },
                init: function($dom){
                    this.dom = $dom;
                    return this;
                },
                clear: function(){
                    if (this.dom) {
                        this.dom.empty();
                    };
                    return this;
                },
                show: function(scope, partial){
                    var dom = this.dom;
                    if ( dom && dom.length ) {
                        dom.empty();
                        if ( partial ) {
                            if ( partial === true ) {
                                partial = 'subnav';
                            }
                            var partial_url = scope.$partial( partial );
                            $templateRequest(partial_url).then(function(html){
                                dom.append( $($compile(html)(scope)) );
                                scope.$emit('SetSubnav', dom);
                            });
                        }
                    }
                }
            };

            function AngularApp(scope, config) {
                config = $.extend(true, {}, defaults, config);

                //初始化全局变量
                var that = this,
                    doms = [];

                this.scope = scope;

                // 即将废除
                scope.$APPS = scope.$APPS || {};
                scope.$APPS[config.key] = this;

                this.primaryKey = config.primary_key || 'id';

                //初始化 key, name
                this.key = config.key;
                this.name = config.name;

                this.isCurrent = config.is_current || ($state.current.url + '/').indexOf(config.api_url + '/') === 0;

                //初始化path
                this.path = provider.modulePath(config.path || that.key);

                if ( !scope.hasOwnProperty('$partial') ) {
                    scope.$partial = function(partial, path){
                        if (path === undefined && config.partials) {
                            path = config.partials[partial];
                            if ( path ) return path;
                        }

                        if ( !path ) {
                            path = that.path;
                        } else if ( path === true ) {
                            path = provider.path.component;
                        } else {
                            if ( provider.extras[path] ) {
                                path = provider.modulePath(path);
                            } else {
                                path = that.path + '/../' + path;
                            }
                        }

                        var html_url = path + '/partials/' +  partial + '.html';
                        html_url = Landers.url.real(html_url);

                        // if ( !provider.cache ) html_url += '?_=' + Math.random();
                        return html_url;
                    };
                }

                //加载css
                if (provider.needCss) {
                    var css_url = that.path + '/style.css';
                    if ( !provider.cache ) css_url += '?_=' + Math.random();
                    doms.push(Landers.loader.css(css_url));
                }

                //初始化ajax
                this.ajax = Ajax.make();

                //Subnav
                if (that.isCurrent) {
                    if ( SubnavManager.hadInit() ) {
                        SubnavManager.show(scope, config.subnav);
                    } else {
                        $rootScope.$on('SetSubnavOjbect', function(event, $subnav){
                            SubnavManager.init($subnav).show(scope, config.subnav);
                        });
                    }
                }

                //初始化runtime (挂载$runtime至scope)
                this.runtime = Runtime.make(scope);
                this.runtime.set('referer', document.referrer);
                this.runtime.set('$app', this); // 即将废除
                if (Flat.get($state, '$current.data.app')) {
                    this.runtime.set('$current', $state.$current.data.app);
                    if (that.isCurrent) this.runtime.set('$current.app', this);
                }

                if ( config.ctrl ) {
                    this.ctrl = angular.extend(config.ctrl, Flat.make(config.ctrl));
                }

                this.$ = {
                    _datkey : function(objectkey, subkey){
                        var datkey = ['$' + objectkey];
                        if (subkey) datkey.push(subkey);
                        return datkey.join('.');
                    },
                    get : function(objectkey, subkey) {
                        var datkey = this._datkey(objectkey, subkey);
                        return Flat.get(scope, datkey);
                    },
                    set : function(objectkey, data, subkey) {
                        var datkey = this._datkey(objectkey);
                        Flat.set(scope, datkey, data, subkey);
                        angular_scope_apply(scope);
                    },
                    extend : function(objectkey, data) {
                        var datkey = this._datkey(objectkey);
                        Flat.extend(scope, data, datkey);
                        angular_scope_apply(scope);
                    }
                };

                //对话框
                this.dialog = {
                    dialogs : [],
                    _attachConfig : function(_dialog_config){
                        var dialog_config = angular.extend({}, _dialog_config || {});
                        if (_dialog_config.event) {
                            if (that.model) {
                                that.model.listitem.active(_dialog_config.event);
                            }
                            dialog_config.onclose = function(){
                                if (that.model) {
                                    that.model.listitem.unactive(_dialog_config.event);
                                }
                                _dialog_config.onclose && _dialog_config.onclose.call(this);
                            };
                            delete dialog_config.event;
                        }
                        if ( _dialog_config.bottombarPartial ) {
                            var bottombar_url = scope.$partial( _dialog_config.bottombarPartial, _dialog_config.partial_path );
                            var bottombar_class = dialog_config.bottombarClass || '';
                            dialog_config.bottombar = '<div ng-include src="\'' + bottombar_url + '\'" class="' + bottombar_class + '"></div>';
                        }

                        if ( _dialog_config.statusbarPartial ) {
                            var bottombar_url = scope.$partial( _dialog_config.statusbarPartial, _dialog_config.partial_path );
                            var statusbar_class = dialog_config.statusbarClass || '';
                            dialog_config.statusbar = '<div ng-include src="\'' + bottombar_url + '\'" class="' + statusbar_class + '"></div>';
                        }
                        // dialog_config.blur = false;
                        return dialog_config;
                    },
                    _loadPartial : function(dialog_config, callback){
                        var partial_url;
                        if ( dialog_config.partial ) {
                            if (angular.isArray(dialog_config.partial)) {
                                partial_url = scope.$partial( dialog_config.partial[0], dialog_config.partial[1] );
                            } else {
                                if (
                                    dialog_config.partial.indexOf('/') === 0 ||
                                    dialog_config.partial.indexOf('../') === 0
                                ) {
                                    partial_url = dialog_config.partial;
                                } else {
                                    partial_url = scope.$partial( dialog_config.partial, dialog_config.partial_path );
                                }
                            }
                        } else {
                            throw ('参数错误');
                        }
                        $templateRequest(partial_url).then(function(html){
                            callback(html);
                        });
                    },

                    show : function(_dialog_config){
                        var dialog_config = this._attachConfig(_dialog_config);
                        var _this = this;
                        var _show = function(){
                            if (_dialog_config.timeout!==false) {
                                _dialog_config.timeout = 30;
                            }
                            if (_dialog_config.timeout) {
                                $timeout(function(){
                                    var dialog = Dialog.show(scope, dialog_config);
                                    _this.dialogs.push(dialog);
                                }, _dialog_config.timeout);
                            } else {
                                console.log('no no');
                                var dialog = Dialog.show(scope, dialog_config);
                                _this.dialogs.push(dialog);
                            }
                        };
                        if (dialog_config.partial) {
                            _this._loadPartial(dialog_config, function(html){
                                dialog_config.html = html;
                                _show();
                            });
                        } else {
                            _show();
                        }
                    },

                    // 传入要显示的内容和按钮的回调
                    confirm : function(mix, callbacks, $event){
                        var _this = this;
                        var dialog_config;
                        if ( angular.isString(mix) ) {
                            // 处理content内容
                            var content = mix.replace(/&/g, "&amp;")
                                .replace(/</g, "&lt;")
                                .replace(/>/g, "&gt;");
                            dialog_config = {
                                content: '<div class=\"confirm\">' + content + '</div>'
                            };
                        } else if (angular.isObject(mix)) {
                            dialog_config = angular.extend({}, mix);
                        }
                        dialog_config = angular.extend({
                            title: '来自'+window.location.host+'的消息',
                            width: 300,
                            event: $event
                        }, dialog_config);

                        dialog_config = this._attachConfig(dialog_config);

                        if ( dialog_config.partial ) {
                            _this._loadPartial(dialog_config, function(html){
                                dialog_config.html = html;
                                var dialog = Dialog.confirm(scope, dialog_config, callbacks);
                                _this.dialogs.push(dialog);
                            });
                        } else {
                            var dialog = Dialog.confirm(scope, dialog_config, callbacks);
                            this.dialogs.push(dialog);
                        }
                    }
                };

                //初始化model
                this.appkey = '$' + config.key;

                if (config.model !== false) {
                    this.model = AngularModel.make(scope, {
                        key : that.key,
                        primaryKey: that.primaryKey,
                        name : that.name,
                        is_current: that.isCurrent,
                        path: {

                        },
                        api_url: (function(){
                            if ( config.api_url ) {
                                return config.api_url;
                            }
                            if ( config.url_style == 'lwap') {
                                return that.path + '/server.php';
                            }
                            return '/' + config.key;
                        })(),
                        url_style : config.url_style,
                        url_params : (function(){
                            var parent_source = config.parent_source;
                            var ret = config.url_params || {};
                            //新参数parent_source
                            if (parent_source && parent_source.app) {
                                ret.related_key = parent_source.app.key;
                                if ( parent_source.listitem ) {
                                    ret.related_id = parent_source.listitem[that.primaryKey];
                                }
                            };
                            //兼容老参数parentApp
                            if (config.parentApp && config.parentApp.prop) {
                                ret.appid = config.parentApp.prop.appid;
                                if ( config.parentEvent ) {
                                    ret.datid = config.parentApp.model.listitem.data(config.parentEvent, 'id');
                                }
                            };
                            return ret;
                        })(),
                        ajax: that.ajax,
                        vice: config.vice,
                        pagesize: config.pagesize,
                        template_urls: config.template_urls
                    });

                    //model.list.popup
                    this.model.list.popup = function(_dialog_config, url_params, callback){
                        var _this = this; url_params = url_params || {};
                        var dialog_config = that.dialog._attachConfig(_dialog_config);
                        dialog_config.onload = function(){
                            var dialog = this.done();
                            var ajax = _this.show({params: url_params});
                            callback && callback(ajax);
                            _dialog_config.onload && _dialog_config.onload.call(dialog);
                            setTimeout(function(){dialog.position();}, 300);
                        };

                        dialog_config = angular.extend({}, {
                            title: that.name + '列表',
                            partial : dialog_config.partial || 'lister',
                            scroll : true,
                            width: 600,
                            height : '100%',
                            no : true
                        }, dialog_config);
                        that.dialog.show(dialog_config);
                    };

                    this.model.detail = {
                        show: function(item, params) {
                            return that.model.listitem.show(item[that.primaryKey], params);
                        },
                        popup: function(item, _dialog_config, params) {
                            var _this = this;
                            var dialog_config = that.dialog._attachConfig(_dialog_config);
                            dialog_config.onload = function() {
                                var dialog = this.done();
                                _this.show(item, params)
                                    .error(function(rspn) {
                                        dialog.done(rspn);
                                    })
                                    .finally(function(){
                                        _dialog_config.onload && _dialog_config.onload.call(dialog);
                                        setTimeout(function(){dialog.position();}, 300);
                                    });
                            };

                            dialog_config = angular.extend({}, {
                                partial: dialog_config.partial || 'detail',
                                scroll: true,
                                loading: {size:'small'},
                                height: '100%',
                                no: true
                            }, dialog_config);
                            that.dialog.show(dialog_config);
                        }
                    };

                    this.model.addedit.popup = function($event, item, _dialog_config) {
                        var dialog_config = that.dialog._attachConfig(_dialog_config);
                        dialog_config.partial = dialog_config.partial || dialog_config.tplkey || 'form';

                        var _this = this, globalDialog;
                        that.dialog._loadPartial(dialog_config, function(dialog_html){
                            _this.show($event, item, function (action, doLoad, doSubmit){
                                if (action.is_edit) {
                                    if (dialog_config.loading === undefined) {
                                        dialog_config.loading = {size:'small'};
                                    }
                                    dialog_config.blur = false;
                                }
                                dialog_config = angular.extend({}, dialog_config, {
                                    event : $event,
                                    title : action.text + (dialog_config.name || that.name),
                                    html: dialog_html,
                                    onload : function(){
                                        globalDialog = this.done();
                                        var onBeforeLoad = dialog_config.onBeforeLoad;
                                        var _onAfterLoad = function(rspn){
                                            var onAfterLoad = dialog_config.onAfterLoad;
                                            onAfterLoad && onAfterLoad.call(that, action, globalDialog, rspn);

                                            if ( AngularModel.isApiResult(rspn) ) globalDialog.done(rspn); else globalDialog.done();
                                        };
                                        var _doLoad = function(){
                                            var ajax = doLoad(_onAfterLoad);
                                            if (ajax) ajax.error(function(rspn){
                                                globalDialog.done(rspn);
                                            });
                                        };
                                        $timeout(function() {
                                            if ( onBeforeLoad ) {
                                                onBeforeLoad(action, globalDialog, _doLoad);
                                            } else {
                                                _doLoad();
                                            }
                                        }, 100);
                                    },
                                    yes : {
                                        text:'保存', fn:function(window, button){
                                            Helpers.disable($(button));
                                            var onBeforeSubmit = dialog_config.onBeforeSubmit;
                                            var onAfterSubmit = dialog_config.onAfterSubmit;
                                            var _doSubmit = function(){
                                                doSubmit()
                                                    .success(function(rspn){
                                                        Helpers.enable($(button));
                                                        onAfterSubmit && onAfterSubmit(action, globalDialog, rspn, item);
                                                        if (!rspn.message) {
                                                            globalDialog.done().close();
                                                        } else {
                                                            if ( action.is_edit ) {
                                                                globalDialog.done(rspn).btn().get('取消').text('关闭');
                                                            } else {
                                                                globalDialog.done().close();
                                                                Landers.response.msgbox(rspn);
                                                            }
                                                        }
                                                    })
                                                    .error(function(rspn){
                                                        if ( angular.isObject(rspn.errors) ) {
                                                            var message = that.model.setErrors('$edit', rspn.errors, false);
                                                            rspn.message = rspn.message || message;
                                                        }
                                                        provider.showDialogError(globalDialog, rspn);
                                                        Helpers.enable($(button));
                                                    });
                                            };

                                            globalDialog.loading({
                                                text : '正在提交数据...',
                                                size : 'long'
                                            }, function(callback_result){
                                                $timeout(function() {
                                                    if ( onBeforeSubmit ) {
                                                        onBeforeSubmit(action, globalDialog, _doSubmit);
                                                    } else {
                                                        _doSubmit();
                                                    }
                                                }, 100);
                                            });
                                            return false;
                                        }
                                    },
                                    no : '取消'
                                });
                                dialog_config.onclose = dialog_config.onclose || function(){
                                    scope.$broadcast('destroy_ueditor');
                                    that.model.setData('$edit', {});
                                };
                                that.dialog.show(dialog_config);
                            });
                        });
                    };

                    this.action = {
                        loading:function(){
                            if (that.ajax) that.ajax.loading();
                            return this;
                        },
                        buildUrl: function(action){
                            var apiurl = that.model.api.buildUrl('custom', {action:action || ''});
                            if ( !action ) {
                                var arr = apiurl.split('/');
                                if ( !arr[arr.length-1] ) {
                                    arr.length--;
                                }
                                apiurl = arr.join('/');
                            }
                            return apiurl;
                        },
                        post : function(action, data, params) {
                            // var apiurl = that.model.api.buildUrl('custom', {action:action});
                            var apiurl = this.buildUrl(action);
                            if (!data && that.model) data = that.model.getData('$edit');
                            if (!that.ajax) throw ('未定义 ajax');
                            return that.ajax.post(apiurl, data, params);
                        },
                        get : function(action, params) {
                            // var apiurl = that.model.api.buildUrl('custom', {action:action});
                            var apiurl = this.buildUrl(action);
                            if (!that.ajax) throw ('未定义 ajax');
                            return that.ajax.get(apiurl, params);
                        },
                        put: function(action, data, params) {
                            var apiurl = this.buildUrl(action);
                            if (!that.ajax) throw ('未定义 ajax');
                            return that.ajax.put(apiurl, data, params);
                        },
                        'delete': function(action, data, params) {
                            var apiurl = this.buildUrl(action);
                            if (!that.ajax) throw ('未定义 ajax');
                            return that.ajax.delete(apiurl, data, params);
                        }
                    };

                    this.appkey = this.model.modelkey;

                    this.model.setData('$angularApp', this);
                }

                this.injectClient = function(name, injects){
                    var url = that.path + '/' + 'client-' + name + '.js';
                    InjectService.module([url], injects);
                };

                this.service = {
                    tagsInput : function(fields, prefix){
                        if (!angular.isArray(fields)) fields = [fields];
                        prefix = prefix || '$edit';
                        angular.forEach(fields, function(item){
                            var value = that.model.getData(prefix, item);
                            var is_array = angular.isArray(value);
                            that.runtime.set(item, {
                                data : value ? value.toString().split(',') : [],
                                onChange : function(){
                                    var value = this.data.map(function(item){
                                        return item.text;
                                    });
                                    if (!is_array) value = value.join(',');
                                    that.model.setData(prefix, value, item);
                                }
                            });
                        });
                    }
                };

                //扩展或覆盖$event
                if ( that.model ) {
                    that.model.extendData('$event', {
                        // 用于外部扩展时方便取得 当前App
                        getApp: function(){
                            return that;
                        },
                        showEdit:function($event, item){
                            $timeout(function() {
                                config.dialog.name = config.name;
                                config.dialog.partial = config.dialog.partial || 'form';
                                that.model.addedit.popup($event, item, config.dialog);
                            }, 100);
                        },
                        showCreate:function($event){
                            this.showEdit($event);
                        }
                    });
                    that.model.extendData('$event', config.events || {});

                } else {
                    Flat.set(scope, that.appkey, config.events, '$event');
                    angular_scope_apply(scope);
                }

                //初始化
                // scope.$errors = {};

                //scope销毁时事件
                scope.$on('$destroy', function(event){
                    config.onDestroy && config.onDestroy(event);

                    //todo: 要调用下面 return对象中的reset
                    that.resetInjectCache();

                    //断开所有连接
                    that.ajax.cancelAll();

                    //清除doms
                    angular.forEach(doms, function(dom){
                        dom.remove();
                    });

                    // Landers.dialog.clear && Landers.dialog.clear();
                    angular.forEach(that.dialog.dialogs, function(dialog){
                        if (dialog && dialog.close) {
                            dialog.close();
                        }
                    });

                    Landers.response.hide();

                    delete that.ajax;
                    delete that.model;
                    delete that.runtime;
                    delete that.$;
                    delete that.scope;
                });

                this.__proto__ = new DynamicInjecte(that.scope);
            }

            function attach_scope_utils_for_ui(scope)
            {
                scope.util = {
                    arrayPush: function(key, dat) {
                        Flat.push(scope, key, dat);
                    },
                    arraySplice: function(key, index, dat) {
                        Flat.splice(scope, key, index, dat)
                    }
                };
            }

            return {
                make : function(scope, config){
                    attach_scope_utils_for_ui(scope);
                    return new AngularApp(scope, config);
                },
                graft: function( scope, mod_name ){
                    return Flat.get(scope, ['$APPS', mod_name].join('.'));
                },
                partial: function(path, partial) {
                    return provider.modulePath(path) + '/partials/' +  partial + '.html';
                },
                provider: provider,
                launch:function(key) {
                    $state.go('base.' + key);
                },
                __proto__: new DynamicInjecte
            };
        }];
    });